uses crt,dos,mouse;

procedure Error(Message:string);
 begin
  clrscr;
  gotoxy(10,10);
  write(Message,#07);
  gotoxy(1,20);
 end;

procedure Print;
 begin
  gotoxy(1,1);
  write('Current mouse position : X=',XMouse,'   ');
  gotoxy(33,1);
  write('Y=',YMouse,'   ');
  gotoxy(50,1);
  write('Mouse buttons: ',Keys,'  ');
  case Keys of
   0:write('(Released)');
   1:write('(Left)    ');
   2:write('(Right)   ');
   3:write('(Both)    ');
  end;
 end;

var OldKeys,AdapterType,FontSize:byte;
    Regs:registers;

 begin
  {GetKeys:=0;}

  AdapterType:=CheckAdapter;
  if (AdapterType<>0) then
   if (CheckMouse<>0) then
    begin
     Regs.AX:=$0100;
     Regs.CX:=$2000;
     intr($10,Regs);

     clrscr;
     gotoxy(1,6);

    { Display information }
    writeln(' ');
    writeln(' ');
    write('  **** Your computer has ');
    if (AdapterType=1) then
                        write('EGA')
                       else
                        write('VGA');
    writeln(' adapter **** ');
    writeln(' ');
    writeln(' ');
    writeln;
    writeln('Press both mouse buttons for EXIT');
    writeln;
    writeln('Press left mouse button for DISPLAY cursor');
    writeln;
    writeln('Press right mouse button for HIDE cursor');

    { Init cursor driver }
    FontSize:=InitMouse;
{    while readkey=#0 do;}
    CorrectChar;
{    while readkey=#0 do;}

    SetRange(0,16,1000,1000);
    DisplayPointer;
    SetHandler;

    { Wait pressing both mouse buttons }
    while Keys<>3 do
     begin
      Print;
      if Keys=0 then OldKeys:=0;
      if Keys=1 then
                  if OldKeys<>1 then
                   begin
                    { Display mouse cursor }
                    DisplayPointer;
                    OldKeys:=1;
                   end;
      if Keys=2 then
                 if OldKeys<>2 then
                                begin
                                 { Hide mouse cursor }
                                 HidePointer;
                                 OldKeys:=2;
                                end;
      if keypressed then break;
     end;
    Print;
    if keypressed then while readkey=#0 do;

    { Wait releasing both mouse buttons }
    while Keys<>0 do;

    { Make cursor visible }
    Regs.AX:=$0100;
    Regs.CX:=$0D0E;
    intr($10,Regs);

    ResetHandler;

    { Locate cursor to bottom of screen }
    gotoxy(1,20);
    end
   else
    Error('ERROR : Mouse not found or mouse driver not installed')
  else
  Error('ERROR : Computer has no EGA or VGA videoadapter');
 end.

